#include <allegro.h>
#include <aldumb.h>
#include <fstream>
#include "tileset.h"
#include "asciiText.h"
#include "maps.h"
using namespace std;

void displayBuffer();
void refreshRateTimerHandler();
void theMasterCloseButton();
void init();
void deinit();
void loopScreeninput(int screen);
void goStartButtons();
void goSetUpGame();
void mainGameLoop();
void govictory(int screen);
void displayTime();
bool checkStationNames(int c);

bool QUIT = 0;
int MODE = 0;
int DIFF = -1;
int oldtextBuffer[60][80] = {{0}};
int textBuffer[60][80] = {{0}};
int mouseX;
int mouseY;
int gameTime = 3600;
int showTime = false;
int missCount = 0;
int stopCount = 0;
volatile int RefreshNow;
int map[58][66] = {{0}};
bool ESC_TOGGLE = false;
bool mouse_TOGGLE = false;
BITMAP* graphics;
PALETTE palette;
int seletedTrain = 0;
int seletedIntersection = 0;
SAMPLE *sample;
tileset fontForText(8, 8, 16, 32, 0, 0);
DUH *myduh;
AL_DUH_PLAYER *dp;
int temp59[4] = {3,8,30,30};

class Traincar{
  public:
    int x;
    int y;
    int phase;
    int dir;
    int tile;
};

class Train{
  public:
    int used;
    int deptStation;
    int destStation;
    int arivalTime;
    int speed;
    Traincar cars[5];
}trains[10];

class Intersections{
  public:
    int used;
    char name;
    int x;
    int y;
    bool left : 1;
    bool right : 1;
    bool up : 1;
    bool down : 1;
    bool transformRoad(int funtion);
}intersections[38];

class Stations{
  public:
    int used;
    char name[4];
    int x;
    int y;
}stations[30];

inline void printToTile(int x, int y, int tile){
  textBuffer[y][x] = tile;
}

void printToTile(int x, int y, char *string){
  int c = 0;
  while(string[c] != 0){
    textBuffer[y][x+c] = string[c];
    c++;
  }
}

inline bool mouseInBox(int x, int y, int w, int h){
  return ((mouseX >= x) && (mouseY >= y) && (mouseX < w) && (mouseY < h));
}

int main() {
  init();
  while (!QUIT){
    switch(MODE){
      case 0:
        al_pause_duh(dp);
        showTime = false;
        play_sample(sample, 255, 128, 1000, 0);
        MODE = 1;
      break; case 1:
        govictory(5);
        MODE = 2;
      break; case 2:
        loopScreeninput(0);
      break; case 3:
        govictory(6);
        MODE = 4;
      break; case 4:
        loopScreeninput(1);
      break; case 5:
        goSetUpGame();
        MODE = -1;
      break; case 6:
        al_pause_duh(dp);
        showTime = false;
        govictory(4);
        MODE = 7;
      break; case 7:
        loopScreeninput(3);
      break; case 9:
        showTime = false;
        govictory(7);
        MODE = 10;
      break; case 10:
        al_poll_duh(dp);
        loopScreeninput(2);
      break; case 12:
        al_pause_duh(dp);
        showTime = false;
        govictory(0);
        MODE = 7;
      break; case 13:
        al_pause_duh(dp);
        showTime = false;
        govictory(3);
        MODE = 7;
      break; case 14:
        al_pause_duh(dp);
        showTime = false;
        govictory(2);
        MODE = 7;
      break; case 15:
        al_pause_duh(dp);
        showTime = false;
        govictory(1);
        MODE = 7;
      break; default:
        mainGameLoop();
        al_poll_duh(dp);
      break;
    }
  }
  deinit();
  return 0;
}
END_OF_MAIN()

void init() {
  int depth, res;
  srand(time(NULL));
  allegro_init();
  atexit(&dumb_exit);
  dumb_register_stdfiles();
  set_color_depth(8);
  res = set_gfx_mode(GFX_AUTODETECT_WINDOWED, 640, 480, 0, 0);
  if (res != 0) {
    allegro_message(allegro_error);
    exit(-1);
  }
  set_window_title("Train Master");
  graphics = load_bitmap("tiles.bmp", palette);
  if (!graphics){
    allegro_message("Couldn't load the bitmap \"tiles.bmp\"!");
    exit(-1);
  }
  set_palette(palette);
  fontForText.bitmap = graphics;
  install_timer();
  install_keyboard();
  install_mouse();
  install_sound(DIGI_AUTODETECT ,MIDI_NONE , NULL);
  show_os_cursor(MOUSE_CURSOR_ARROW);// because I like the real cursor better
  set_close_button_callback(theMasterCloseButton);
  LOCK_VARIABLE(RefreshNow);
  LOCK_FUNCTION(refreshRateTimerHandler);
  install_int_ex(refreshRateTimerHandler,BPS_TO_TIMER(60));
  sample = load_wav("intro.wav");
  myduh = dumb_load_it_quick("main music.it");
  dumb_resampling_quality = 1;
  dp = al_start_duh(myduh, 1, 0, 1, 4096, 44100);
}

void deinit() {
  destroy_sample(sample);
  al_stop_duh(dp);
  unload_duh(myduh);
  clear_keybuf();
  destroy_bitmap(graphics);
}

void refreshRateTimerHandler(){
  RefreshNow++;
}
END_OF_FUNCTION(refreshRateTimerHandler);

void theMasterCloseButton(){
  QUIT = true;
}
END_OF_FUNCTION(theMasterCloseButton)

void displayTime(){
  BITMAP *temp = create_bitmap(64, 8);
  fontForText.blit(temp, 0, 0, ((gameTime/36000)%4)+0x30, 0);
  fontForText.blit(temp, 8, 0, ((gameTime/3600)%10)+0x30, 0);
  fontForText.blit(temp, 16, 0, ':', 0);
  fontForText.blit(temp, 24, 0, ((gameTime/600)%6)+0x30, 0);
  fontForText.blit(temp, 32, 0, ((gameTime/60)%10)+0x30, 0);
  fontForText.blit(temp, 40, 0, '.', 0);
  fontForText.blit(temp, 48, 0, ((gameTime/10)%6)+0x30, 0);
  fontForText.blit(temp, 56, 0, (gameTime%10)+0x30, 0);
  stretch_blit(temp, screen, 0, 0, 64, 8, 400, 0, 128, 16);
  destroy_bitmap(temp);
  BITMAP *temp2 = create_bitmap(8, 8);
  fontForText.blit(temp2, 0, 0, map[intersections[seletedIntersection].y]
                                [intersections[seletedIntersection].x], 0);
  stretch_blit(temp2, screen, 0, 0, 8, 8, 568, 408, 64, 64);
  destroy_bitmap(temp2);
}

void splat(int x, int y){
  for(int x2 = x-1; x2 < x+2; x2++){
    for(int y2 = y-1; y2 < y+2; y2++){
      oldtextBuffer[y2][x2] = -1;
    }
  }
}

void displayBuffer(){
  static bool ESC_KEY_was_pressed = false;
  static bool mouse_was_pressed = false;
  while(RefreshNow==0){
    rest(1);
  }
  RefreshNow = 0;
  acquire_screen();
  /*if(showTime){
    textBuffer[intersections[seletedIntersection].y + 2]
              [intersections[seletedIntersection].x] += 0x20;
  }*/
  for(int y = 0; y < 60; y++){
    for(int x = 0; x < 80; x++){
      if(textBuffer[y][x] != oldtextBuffer[y][x]){
        fontForText.blit(screen, x*8, y*8, textBuffer[y][x], 0);
        oldtextBuffer[y][x] = textBuffer[y][x];
      }
    }
  }
  if(showTime){
    displayTime();
    int x = intersections[seletedIntersection].x;
    int y = intersections[seletedIntersection].y + 2;
    fontForText.blit(screen, x*8, y*8, textBuffer[y][x] + 0x20, 0);
    oldtextBuffer[y][x] = -1;
    for(int i = 0; i < 10; i++){
      if(trains[i].used){
        for(int j = 0; j < 5; j++){
          x = trains[i].cars[j].x;
          y = trains[i].cars[j].y;
          int tile = trains[i].cars[j].tile;
          int phase = trains[i].cars[j].phase;
          int dir = trains[i].cars[j].dir;
          //int speed = trains[i].speed;
          BITMAP *temp2 = create_bitmap(8, 8);
          fontForText.blit(temp2, 0, 0,0x0180+j, 0);
          if((tile == 0x0108)&&(dir == 0)){
            phase = phase/8192 - 4;
            pivot_sprite(screen, temp2, (x*8)+4, ((y+2)*8)-phase+4, 4, 4, itofix(192));
          }
          if((tile == 0x0109)&&(dir == 1)){
            phase = phase/8192 - 4;
            pivot_sprite(screen, temp2, (x*8)+phase+4, ((y+2)*8)+4, 4, 4, itofix(0));
          }
          if((tile == 0x0108)&&(dir == 2)){
            phase = phase/8192 - 4;
            pivot_sprite(screen, temp2, (x*8)+4, ((y+2)*8)+phase+4, 4, 4, itofix(64));
          }
          if((tile == 0x0109)&&(dir == 3)){
            phase = phase/8192 - 4;
            pivot_sprite(screen, temp2, (x*8)-phase+4, ((y+2)*8)+4, 4, 4, itofix(128));
          }
          /*if((tile == 0x010b)&&(dir == 2)&&(speed>=0)){
            phase = phase/1024;
            pivot_sprite(screen, temp2, (x*8), ((y+2)*8)+8, 4, 8, itofix(phase));
          }*/
          destroy_bitmap(temp2);
          /*else{
            int phase = trains[i].cars[j].phase/1024;
            int dir = trains[i].cars[j].dir;
            BITMAP *temp2 = create_bitmap(8, 8);
            fontForText.blit(temp2, 0, 0,0x0180+(j*4), 0);
            pivot_sprite(screen, temp2, x*8, (y+2)*8+7, 7, 3, itofix(phase+64));
            destroy_bitmap(temp2);
          }*/
          splat(x, y + 2);
        }
        x = trains[i].cars[0].x;
        y = trains[i].cars[0].y;
        int phase = trains[i].cars[0].phase/8192 - 4;
        int dir = trains[i].cars[0].dir;
        if(dir == 0){
          fontForText.blit(screen, (x*8), ((y+1)*8)-phase, ((i+1)%10)+0x30, 0);
        }
        if(dir == 1){
          fontForText.blit(screen, (x*8)+phase, ((y+1)*8), ((i+1)%10)+0x30, 0);
        }
        if(dir == 2){
          fontForText.blit(screen, (x*8), ((y+1)*8)+phase, ((i+1)%10)+0x30, 0);
        }
        if(dir == 3){
          fontForText.blit(screen, (x*8)-phase, ((y+1)*8), ((i+1)%10)+0x30, 0);
        }
        splat(x, y + 1);
      }
    }
  }
  release_screen();
  poll_mouse();
  mouseX = mouse_x/8;
  mouseY = mouse_y/8;
  if(!ESC_KEY_was_pressed && key[KEY_ESC]){
    ESC_TOGGLE = true;
  }else{
    ESC_TOGGLE = false;
  }
  if(!mouse_was_pressed && mouse_b){
    mouse_TOGGLE = true;
  }else{
    mouse_TOGGLE = false;
  }
  ESC_KEY_was_pressed = key[KEY_ESC];
  mouse_was_pressed = mouse_b;
  //textprintf_ex(screen, font, 536, 472, makecol(255,255,0), 0, 
  //              "X:%d,Y:%d  ", mouseX, mouseY);
}

void loopScreeninput(int screen){
  switch(screen){
  case 0:
    if(mouse_b){
      if(mouseInBox(54, 47, 78, 52))MODE = 3;
      if(mouseInBox(59, 56, 79, 59))QUIT = true;
    }
    if(key[KEY_ENTER])MODE = 3;
    if(ESC_TOGGLE)QUIT = true;
  break;
  case 1:
    if(mouse_b){
      if(mouseInBox(59, 49, 79, 52))QUIT = true;
      if(mouseInBox(4, 54, 19, 59)){DIFF = 0; MODE = 5;}
      if(mouseInBox(23, 54, 38, 59)){DIFF = 1; MODE = 5;}
      if(mouseInBox(42, 54, 57, 59)){DIFF = 2; MODE = 5;}
      if(mouseInBox(61, 54, 76, 59)){DIFF = 3; MODE = 5;}
    }
    if(key[KEY_1]){DIFF = 0; MODE = 5;}
    if(key[KEY_2]){DIFF = 1; MODE = 5;}
    if(key[KEY_3]){DIFF = 2; MODE = 5;}
    if(key[KEY_4]){DIFF = 3; MODE = 5;}
    if(ESC_TOGGLE)QUIT = true;
  break;
  case 2:
    if(mouse_TOGGLE){
      if(mouseInBox(0, 0, 11, 1))MODE = -1;
      if(mouseInBox(54, 59, 79, 60))MODE = 0;
    }
    if(key[KEY_BACKSPACE])MODE = 0;
    if(ESC_TOGGLE)MODE = -1;
  break;
  case 3:
    if(mouse_TOGGLE){
      MODE = 0;
    }
    if(ESC_TOGGLE){
      MODE = 0;
    }
    if(key[KEY_ENTER]){
      MODE = 0;
    }
  break;
  }
  displayBuffer();
}


void drawMainGame(){
  for(int x = 0; x < 66; x++){
    printToTile(x,0,'\0');
    printToTile(x,1,0xc4);
    for(int y = 0; y < 58; y++){
      printToTile(x,y+2,map[y][x]);
    }
  }
  for(int y = 0; y < 60; y++){
    printToTile(66,y,0xba);
  }
  for(int y = 0; y < 60; y++){
    for(int x = 67; x < 80; x++){
      printToTile(x,y,'\0');
    }
  }
  for(int y = 0; y < 11; y++){
    printToTile(66,y*5,0xc7);
    for(int x = 67; x < 80; x++){
      printToTile(x,y*5,0xc4);
    }
  }
  printToTile(0,0,"HELP (esc)| missCount: #| completed: ");
  printToTile(23,0,missCount+0x30);
  printToTile(37,0,stopCount+0x30);
  printToTile(66,1,0xb6);
  for(int x = 0; x < 10; x++){
    if(trains[x].used){
      printToTile(67,5*x+1,"Train No");
      textBuffer[5*x+1][76] = ((x+1)%10) + 0x30;
      if(x == seletedTrain)printToTile(79,5*x+1,0xdb);
      printToTile(76,5*x+2,stations[trains[x].destStation].name);
      printToTile(69,5*x+2,stations[trains[x].deptStation].name);
      printToTile(73,5*x+2,"To");
      printToTile(67,5*x+3,"AT");
      int tempT = trains[x].arivalTime;
      printToTile(70,5*x+3,((tempT/36000)%4)+0x30);
      printToTile(71,5*x+3,((tempT/3600)%10)+0x30);
      printToTile(72,5*x+3,':');
      printToTile(73,5*x+3,((tempT/600)%6)+0x30);
      printToTile(74,5*x+3,((tempT/60)%10)+0x30);
      printToTile(75,5*x+3,'.');
      printToTile(76,5*x+3,((tempT/10)%6)+0x30);
      printToTile(77,5*x+3,(tempT%10)+0x30);
      int tempS = trains[x].speed;
      //tempS += 1000000;
      printToTile(67,5*x+4,"Speed");
      if(tempS >= 0){
        printToTile(73,5*x+4,' ');
      }else{
        tempS = -tempS;
        printToTile(73,5*x+4,'-');
      }
      printToTile(74,5*x+4,((tempS/1000)%10) + 0x30);
      printToTile(75,5*x+4,((tempS/100)%10) + 0x30);
      printToTile(76,5*x+4,((tempS/10)%10) + 0x30);
      printToTile(77,5*x+4,(tempS%10) + 0x30);
    }
  }
  displayBuffer();
}

bool Intersections::transformRoad(int funtion){
  for(int i = 0; i < 10; i++){
    if(trains[i].used){
      for(int j = 0; j < 5; j++){
        if((trains[i].cars[j].x == x)&&(trains[i].cars[j].y == y)){
          return false;
        }
      }
    }
  }
  switch(funtion){
    case 0:
    if(down && up){
      map[y][x] = 0x108;
      return true;
    }
    break;case 1:
    if(right && left){
      map[y][x] = 0x109;
      return true;
    }
    break;case 2:
    if(right && left && down && up){
      map[y][x] = 0x10f;
      return true;
    }else if(up && left){
      map[y][x] = 0x10d;
      return true;
    }else if(down && right){
      map[y][x] = 0x10a;
      return true;
    }
    break;case 3:
    if(right && left && down && up){
      map[y][x] = 0x10e;
      return true;
    }else if(down && left){
      map[y][x] = 0x10b;
      return true;
    }else if(up && right){
      map[y][x] = 0x10c;
      return true;
    }
    break;
  }
  return false;
}

char keboardtextthing[38] = {
'q','w','e','r','t','y','u','i','o','p','a','s','d',
'f','g','h','j','k','l','z','x','c','v','b','n','m',
'Q','W','E','R','A','S','D','F','Z','X','C','V'};

char keboardtextthing2[52] = {
'a','b','c','d','e','f','g','h','i','j','k','l','m',
'n','o','p','q','r','s','t','u','v','w','x','y','z',
'A','B','C','D','E','F','G','H','I','J','K','L','M',
'N','O','P','Q','R','S','T','U','V','W','X','Y','Z',};

bool checkStationNames(int c){
  for(int i = 0; i < 30; i++){
    if(!stations[i].used){
      if((stations[c].name[0] == stations[i].name[0])&&
         (stations[c].name[1] == stations[i].name[1])){
        return false;
      }
    }
  }
  return true;
}

void goSetUpGame(){
  fade_out(2);
  gameTime = 10800;
  missCount = 0;
  stopCount = 0;
  for(int i = 0; i < 38; i++){
    intersections[i].used = false;
  }
  for(int i = 0; i < 30; i++){
    stations[i].used = false;
  }
  for(int i = 0; i < 10; i++){
    trains[i].used = false;
  }
  for(int x = 0; x < 58*66; x++){
    switch(DIFF){
      case 0:
        map[x/66][x%66] = forDummiesMap1[x];
      break;case 1:
        map[x/66][x%66] = normalMap[x];
      break;case 2:
        map[x/66][x%66] = quiteDifficaultMap[x];
      break;case 3:
        map[x/66][x%66] = noFairMap[x];
      break;
    }
  }
  for(int y = 1; y < 57; y++){
    for(int x = 1; x < 65; x++){
      if(map[y][x] == 0xff){
        for(int i = 0; i < 38; i++){
          if(!intersections[i].used){
            intersections[i].used = true;
            intersections[i].x = x;
            intersections[i].y = y;
            intersections[i].name = keboardtextthing[i];
            map[y-1][x-1] = intersections[i].name;
            intersections[i].right = (map[y][x+1] == 0x109) ? true : false;
            intersections[i].left = (map[y][x-1] == 0x109) ? true : false;
            intersections[i].down = (map[y+1][x] == 0x108) ? true : false;
            intersections[i].up = (map[y-1][x] == 0x108) ? true : false;
            seletedIntersection = i;
            while(!intersections[i].transformRoad(rand()%4)){;}
            break;
          }
        }
      }else if(map[y][x] == 0x015a){
        for(int i = 0; i < 30; i++){
          if(!stations[i].used){
            stations[i].used = true;
            stations[i].x = x;
            stations[i].y = y;
            do{
            stations[i].name[0] = (rand()%26) + 0x41;
            stations[i].name[1] = (rand()%26) + 0x41;
            stations[i].name[2] = 'S';
            stations[i].name[3] = 0;
            } while (!checkStationNames(i));
            map[y][x-1] = stations[i].name[0];
            map[y][x] = stations[i].name[1];
            map[y][x+1] = stations[i].name[2];
            if(map[y][x+2] == 0x108)stations[i].x += 2;
            else if(map[y][x-2] == 0x108)stations[i].x -= 2;
            else if(map[y+2][x] == 0x109)stations[i].y += 2;
            else if(map[y-2][x] == 0x109)stations[i].y -= 2;
            break;
          }
        }
      }
    }
  }
  int temp56[4] = {1,3,10,10};
  int temp57[4][10] = {
      {0},
      {0,3,5},
      {0,3,6,9,12,15,18,21,24,27},
      {0,3,6,9,12,15,18,21,24,27}};
  int temp58[4][10] = {
      {0},
      {0,3,1},
      {1,0,3,2,1,0,3,2,1,0},
      {1,0,3,2,1,0,3,2,1,0}};
  for(int x = 0; x < temp56[DIFF]; x++){
    trains[x].used = true;
    trains[x].deptStation = temp57[DIFF][x];
    int i = trains[x].deptStation;
    while(trains[x].destStation == trains[x].deptStation){
      trains[x].destStation = rand()%temp59[DIFF];
    }
    trains[x].arivalTime = gameTime + 7200;
    trains[x].speed = 0;
    for(int y = 0; y < 5; y++){
      if(temp58[DIFF][x] == 0){
        trains[x].cars[y].x = stations[i].x;
        trains[x].cars[y].y = stations[i].y + y-2;
      }else if(temp58[DIFF][x] == 1){
        trains[x].cars[y].x = stations[i].x + 2-y;
        trains[x].cars[y].y = stations[i].y;
      }else if(temp58[DIFF][x] == 2){
        trains[x].cars[y].x = stations[i].x;
        trains[x].cars[y].y = stations[i].y + 2-y;
      }else if(temp58[DIFF][x] == 3){
        trains[x].cars[y].x = stations[i].x + y-2;
        trains[x].cars[y].y = stations[i].y;
      }
      trains[x].cars[y].tile = map[trains[x].cars[y].y][trains[x].cars[y].x];
      trains[x].cars[y].phase = 0;
      trains[x].cars[y].dir = temp58[DIFF][x];
    }
  }
  /*if(DIFF == 0){
    for(int x = 0; x < 1; x++){
      trains[x].used = true;
      trains[x].deptStation = 0;
      trains[x].destStation = 2;
      trains[x].arivalTime = gameTime + 3600;
      trains[x].speed = 0;
      trains[x].phase = 0;
      trains[x].x = stations[trains[x].deptStation].x;
      trains[x].y = stations[trains[x].deptStation].y;
      trains[x].dir = 2;
    }
  }
  if(DIFF == 2){
    for(int x = 0; x < 10; x++){
      trains[x].used = true;
      trains[x].deptStation = rand()%30;
      trains[x].destStation = rand()%30;
      trains[x].arivalTime = rand()%3600;
      trains[x].speed = rand()%1000;
      trains[x].phase = (rand()%65536) - 32768;
      trains[x].x = stations[trains[x].deptStation].x;
      trains[x].y = stations[trains[x].deptStation].y;
      trains[x].dir = rand()%4;
    }
  }*/
  showTime = true;
  seletedIntersection = 0;
  seletedTrain = 0;
  drawMainGame();
  fade_in(palette, 2);
  stop_sample(sample);
  dp = al_start_duh(myduh, 1, 0, 1, 4096, 44100);
}

void govictory(int screen){
  switch(screen){
  case 0:
    for(int y = 0; y < 46; y++){
      for(int x = 0; x < 80; x++){
        textBuffer[y][x] = asciiText[y][x];
      }
      displayBuffer();
    }
    for(int y = 0; y < 14; y++){
      for(int x = 0; x < 80; x++){
        textBuffer[y+46][x] = asciiText[67+y][x];
      }
      displayBuffer();
    }
  break;
  case 1:
    for(int y = 0; y < 60; y++){
      for(int x = 0; x < 80; x++){
        textBuffer[y][x] = asciiText[y+81][x];
      }
      displayBuffer();
    }
  break;
  case 2:
    for(int y = 0; y < 60; y++){
      for(int x = 0; x < 80; x++){
        textBuffer[y][x] = asciiText[y+141][x];
      }
      displayBuffer();
    }
  break;
  case 3:
    for(int y = 0; y < 60; y++){
      for(int x = 0; x < 80; x++){
        textBuffer[y][x] = asciiText[y+201][x];
      }
      displayBuffer();
    }
  break;
  case 4:
    for(int x = 0; x < 40; x++){
      for(int y = 0; y < 60; y++){
        textBuffer[y][x] = asciiText[y+261][x];
        textBuffer[y][79-x] = asciiText[y+261][79-x];
      }
      displayBuffer();
    }
  break;
  case 5:
    for(int y = 0; y < 60; y++){
      for(int x = 0; x < 80; x++){
        textBuffer[y][x] = asciiText[y][x];
        oldtextBuffer[y][x] = -1;
      }
    }
    displayBuffer();
  break;
  case 6:
    for(int s = 0; s < 7; s++){
      for(int x = 0; x < 80; x++){
        for(int y = 0; y < 59; y++){
          textBuffer[y][x] = textBuffer[y+1][x];
        }
        textBuffer[59][x] = asciiText[60+s][x];
      }
      displayBuffer();
      displayBuffer();
    }
  break;
  case 7:
    for(int y = 0; y < 4; y++){
      for(int x = 0; x < 80; x++){
        textBuffer[y+2][x] = asciiText[y+321+(DIFF*4)][x];
        oldtextBuffer[y+2][x] = -1;
      }
    }
    for(int y = 0; y < 54; y++){
      for(int x = 0; x < 80; x++){
        textBuffer[y+6][x] = asciiText[y+337][x];
        oldtextBuffer[y+6][x] = -1;
      }
    }
  displayBuffer();
  break;
  }
}

bool moveTrains(){
  for(int i = 0; i < 10; i++){
    if(trains[i].used){
      for(int j = 0; j < 5; j++){
        trains[i].cars[j].phase += trains[i].speed;
        int tempTable[2][4][8] = {
           {{0,5,1,3,5,5,3,1},
            {5,1,5,2,5,0,2,0},
            {2,5,5,5,1,3,1,3},
            {5,3,2,5,0,5,0,2}},
           {{0,5,5,5,3,1,3,1},
            {5,1,0,5,2,5,2,0},
            {2,5,3,1,5,5,1,3},
            {5,3,5,0,5,2,0,2}}};
        if(trains[i].cars[j].phase > 65536){
          if(trains[i].cars[j].dir == 0)trains[i].cars[j].y--;
          if(trains[i].cars[j].dir == 1)trains[i].cars[j].x++;
          if(trains[i].cars[j].dir == 2)trains[i].cars[j].y++;
          if(trains[i].cars[j].dir == 3)trains[i].cars[j].x--;
          trains[i].cars[j].phase -= 65536;
          trains[i].cars[j].tile = map[trains[i].cars[j].y][trains[i].cars[j].x];
          trains[i].cars[j].dir = tempTable[0][trains[i].cars[j].dir]
                                  [trains[i].cars[j].tile-0x0108];
          if(trains[i].cars[j].dir == 5){
            return false;
          }
        }
        if(trains[i].cars[j].phase < 0){
          if(trains[i].cars[j].dir == 0)trains[i].cars[j].y++;
          if(trains[i].cars[j].dir == 1)trains[i].cars[j].x--;
          if(trains[i].cars[j].dir == 2)trains[i].cars[j].y--;
          if(trains[i].cars[j].dir == 3)trains[i].cars[j].x++;
          trains[i].cars[j].phase += 65536;
          trains[i].cars[j].tile = map[trains[i].cars[j].y][trains[i].cars[j].x];
          trains[i].cars[j].dir = tempTable[1][trains[i].cars[j].dir]
                                  [trains[i].cars[j].tile-0x0108];
          if(trains[i].cars[j].dir == 5){
            return false;
          }
        }
        if((trains[i].cars[j].tile > 0x0109)&&
           (trains[i].speed < 100)&&(trains[i].speed > 0)){
          trains[i].speed = 100;
        }else if((trains[i].cars[j].tile > 0x0109)&&
           (trains[i].speed > -100)&&(trains[i].speed <= 0)){
          trains[i].speed = -100;
        }
      }
    }
  }
  return true;
}

bool checkStations(int i){
  if(trains[i].arivalTime < gameTime){
    missCount++;
  }
  for(int x = 0; x < 30; x++){
    if(trains[i].used){
      for(int j = 0; j < 5; j++){
        if((trains[i].cars[j].x == stations[trains[i].destStation].x)&&
          (trains[i].cars[j].y == stations[trains[i].destStation].y)){
          trains[i].deptStation = trains[i].destStation;
          trains[x].arivalTime = gameTime + 7200;
          int i = trains[x].deptStation;
          while(!stations[i].used ||
            (trains[x].destStation == trains[x].deptStation)){
             trains[x].destStation = rand()%temp59[DIFF];
          }
          stopCount++;
        }
      }
    }
  }
  return false;
}

void mainGameLoop(){
  showTime = true;
  if(mouse_TOGGLE){
    if(mouseInBox(0, 0, 11, 1))MODE = 9;
  }
  if(ESC_TOGGLE)MODE = 9;
  if(key[KEY_1] && trains[0].used)seletedTrain = 0;
  if(key[KEY_2] && trains[1].used)seletedTrain = 1;
  if(key[KEY_3] && trains[2].used)seletedTrain = 2;
  if(key[KEY_4] && trains[3].used)seletedTrain = 3;
  if(key[KEY_5] && trains[4].used)seletedTrain = 4;
  if(key[KEY_6] && trains[5].used)seletedTrain = 5;
  if(key[KEY_7] && trains[6].used)seletedTrain = 6;
  if(key[KEY_8] && trains[7].used)seletedTrain = 7;
  if(key[KEY_9] && trains[8].used)seletedTrain = 8;
  if(key[KEY_0] && trains[9].used)seletedTrain = 9;
  if(mouse_b){
    if(mouseInBox(67, 1, 80, 5))seletedTrain = 0;
    if(mouseInBox(67, 6, 80, 10))seletedTrain = 1;
    if(mouseInBox(67, 11, 80, 15))seletedTrain = 2;
    if(mouseInBox(67, 16, 80, 20))seletedTrain = 3;
    if(mouseInBox(67, 21, 80, 25))seletedTrain = 4;
    if(mouseInBox(67, 26, 80, 30))seletedTrain = 5;
    if(mouseInBox(67, 31, 80, 35))seletedTrain = 6;
    if(mouseInBox(67, 36, 80, 40))seletedTrain = 7;
    if(mouseInBox(67, 41, 80, 45))seletedTrain = 8;
    if(mouseInBox(67, 46, 80, 50))seletedTrain = 9;
  }
  //this assumes that KEY_A is first and KEY_Z is last
  for(int x = KEY_A; x < KEY_Z+1; x++){
    if(key[x]){
      if(key[KEY_LSHIFT] || key[KEY_RSHIFT]){
        for(int i = 0; i < 38; i++){
          if(keboardtextthing2[x-KEY_A+26] == intersections[i].name){
            seletedIntersection = i;
          }
        }
      }else{
        for(int i = 0; i < 38; i++){
          if(keboardtextthing2[x-KEY_A] == intersections[i].name){
            seletedIntersection = i;
          }
        }
      }
    }
  }
  if(mouse_b){
    for(int i = 0; i < 38; i++){
       if((mouseX == intersections[i].x)&&(mouseY == (intersections[i].y+2))){
          seletedIntersection = i;
       }
    }
  }
/*if(map[y][x+1] == 0x109)intersections[i].right = true;
  if(map[y][x-1] == 0x109)intersections[i].left = true;
  if(map[y+1][x] == 0x108)intersections[i].down = true;
  if(map[y-1][x] == 0x108)intersections[i].up = true;*/
  if(key[KEY_F1]){
    intersections[seletedIntersection].transformRoad(0);
  }
  if(key[KEY_F2]){
    intersections[seletedIntersection].transformRoad(1);
  }
  if(key[KEY_F3]){
    intersections[seletedIntersection].transformRoad(2);
  }
  if(key[KEY_F4]){
    intersections[seletedIntersection].transformRoad(3);
  }
  if(key[KEY_UP]){
    trains[seletedTrain].speed += 7;
  }else if(key[KEY_DOWN]){
    if(trains[seletedTrain].speed > 0){
      trains[seletedTrain].speed -= 28;
    }else{
      trains[seletedTrain].speed -= 7;
    }
  }else if((trains[seletedTrain].speed < 100)&&
           (trains[seletedTrain].speed > -100)){
    trains[seletedTrain].speed = 0;
    checkStations(seletedTrain);
  }
  if(trains[seletedTrain].speed > 9999){
    trains[seletedTrain].speed = 9999;
  }
  if(trains[seletedTrain].speed < -1000){
    trains[seletedTrain].speed = -1000;
  }
  if(((moveTrains() == false)&&(DIFF < 3)) || (missCount > 4)){
    MODE = 6;
  }else if(((moveTrains() == false)&&(DIFF == 3))){
    MODE = 15;
  }
  if((stopCount >= 4)&&(DIFF == 0)){
    MODE = 12;
  }
  if((stopCount >= 10)&&(DIFF == 1)){
    MODE = 13;
  }
  if((stopCount >= 40)&&(DIFF == 2)){
    MODE = 14;
  }
  if(DIFF == 3){
    gameTime--;
  }else{
    gameTime++;
  }
  drawMainGame();
}
